package org.zipcoder.store;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() {
        return (size()==0);
    }

    @Override
    public Cart get(User key) {
        Iterator<Entry> entryIterator = entries.iterator();
        Entry retrievedEntry;
        Cart retrievedCart = null;
        while (entryIterator.hasNext()){
            retrievedEntry = entryIterator.next();
            if (retrievedEntry.getKey().equals(key)){
                retrievedCart = retrievedEntry.getValue();
            }
        }
        return retrievedCart;
    }

    @Override
    public void put(User key, Cart value) {
        Entry newEntry = new Entry(key, value);
        entries.add(newEntry);
    }


    @Override
    public List<User> getKeys() {
        List<User> entriesUser = new ArrayList<>();
        for (Entry e : entries){
            entriesUser.add(e.getKey());
        }
        return entriesUser;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> entriesCart = new ArrayList<>();
        for (Entry e : entries){
            entriesCart.add(e.getValue());
        }
        return entriesCart;
    }

    @Override
    public Cart remove(User key) {
        Cart removedCart = null;
        for (int i=0; i<entries.size(); i++){
            if (entries.get(i).getKey() == key){
                removedCart = entries.get(i).getValue();
                entries.remove(entries.get(i));
            }
        }
        return removedCart;
    }
}
