package org.zipcoder.store;

import java.util.Objects;

public class User {

    private long id;
    private String name;

    public User(){}

    public User(long id) {
        this.id = id;
    }

    public User(String name) {
        this.name = name;
    }

    public User(long id, String name){
        this.id = id;
        this.name = name;
    }

    @Override
    public boolean equals(Object o){
        User u = (User) o;
        if(name != null && u.getName() != null) {
            return(id == u.getId() && name.equals(u.getName()));
        } else {
            return(id == u.getId());
        }
    }

    @Override
    public int hashCode(){
        return Objects.hash(id, name);
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
